diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx
index 02779262b..28ba94b4f 100644
--- a/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx
@@ -1194,7 +1194,12 @@ export function ResultSet() {
 
   useEffect(()=>{
     const renderGeometries = (column)=>{
-      let selRowsData = selectedRows.size === 0 ? rows : rows.filter((r)=>selectedRows.has(rowKeyGetter(r)));
+      let selRowsData = rows;
+      if(selectedRows.size != 0) {
+        selRowsData = rows.filter((r)=>selectedRows.has(rowKeyGetter(r)));
+      } else if(selectedCell.current[0]) {
+        selRowsData = [selectedCell.current[0]];
+      }
       LayoutHelper.openTab(queryToolCtx.docker, {
         id: PANELS.GEOMETRY,
         title:gettext('Geometry Viewer'),
